﻿//Данные менять здесь! (если оставить пустую строку (две кавычки "") то подмены не будет, вернется реальное значение!)
var IMEI = "";
var AND_ID = "88888888";
var PHONE = "";
var INSTALLER = "com.android.vending";
//Дальше ничего лучше не трогать!

var Log = null;
var Fix = null;
var Injector = null;
var fdone = null;
var APP_PKG = null;

var TAG_L = "[FRIDA_SCRIPT]";

function patch() {

    Log = Java.use("android.util.Log");
    Fix = Java.use("com.frida.Fix");
    Injector = Java.use("com.frida.injector");
    fdone = Injector.getAppFilesDir() + "/done";
    APP_PKG = Injector.getAppPackageName();

    Log.v(TAG_L, "[*] Start patching...");

    var PackageManager = Java.use("android.app.ApplicationPackageManager");
    PackageManager.getPackageInfo.implementation = function (package_name, flags) {
        var ret = this.getPackageInfo.call(this, package_name, flags);
        if (APP_PKG == package_name) {
            Log.v(TAG_L, "[*] Get package info for '" + package_name + "' signatures replaced to Fixed.");
            ret.signatures = Fix.getSignatures(ret);
        } else {
            Log.v(TAG_L, "[*] Get package info for '" + package_name + "' signatures not replaced.");
        }

        return ret;
    };

    PackageManager.getInstallerPackageName.implementation = function (package_name) {
        var ret = this.getInstallerPackageName.call(this, package_name);
        Log.v(TAG_L, "[*] Get installer for '" + package_name + "' called.");
        if (APP_PKG == package_name) {
            if (INSTALLER != ""){
                ret = INSTALLER;
            }
        }
        return ret;
    };


    var Signature = Java.use("java.security.Signature");
    Signature.verify.overload('[B').implementation = function (p1) {
        var ret = this.verify.call(this, p1);
        Log.v(TAG_L, "[*] Signature.verify is " + ret + " replaced to true.");
        return true;
    };

    var TelephonyManager = Java.use("android.telephony.TelephonyManager");
    TelephonyManager.getDeviceId.overload().implementation = function () {
        var ret = this.getDeviceId.call(this);
        if (IMEI != ""){
            ret = IMEI;
        }
        Log.v(TAG_L,"[*] Get device id (IMEI) called. IMEI = "+ret);
        return ret;
    };

    TelephonyManager.getLine1Number.overload().implementation = function () {
        var ret = this.getLine1Number.call(this);
        if (PHONE != ""){
            ret = PHONE;
        }
        Log.v(TAG_L,"[*] Get PHONE_NUMBER called. Phone = "+ret);
        return ret;
    };

    var Settings = Java.use("android.provider.Settings$Secure");
    Settings.getString.overload('android.content.ContentResolver', 'java.lang.String').implementation = function (p1,p2) {
        var ret = this.getString.call(this,p1,p2);
        if (p2.indexOf("android_id") != -1){
            if(AND_ID !=""){
                ret = AND_ID;
            }
        }
        Log.v(TAG_L,"[*] Get ANDROID_ID called. ANDROID_ID = "+ret);
        return ret;
    };


    Log.v(TAG_L, "[*] Patching done...");

    continue_run();
};

function continue_run() {
    var f = new File(fdone, "w");
    f.write("1");
    f.flush();
    f.close();
    setTimeout(continue_run, 1000);
};

function run() {
    console.log("Waiting for Java..");

    while (!Java.available) {
        console.error("Java not available yet");
    }

    console.log("[*] Starting script");

    Java.perform(patch);

};

setTimeout(run, 20);